//-------------------------
//Author:S.Kambiz Hosseini
//Version:v1.00
//description:designed for lcd 16*2
//-------------------------
//--------------------------------------------------------------------------
//  comm2 (unsigned char c) ---------------->send control bit              //
//  datw (unsigned char c)  ------------------->send data bit              //
//  lcd4_init(void)------------------------->initializing lcd              //
//  lcd_clear(void)---------------------------->clear all lcd              //
//  lcd_gotoxy(char x,char y)---------------->control lcd x,y              //
//  lcd_putsf(char  *str)-------->set data from memory to lcd              //
//   lcd_puts(char *str)--------->set data // // // // 					   //
//  cursor_on(void)------------------------>set cursor on                  //
//  cursor_off(void)---------------------->turn off cursor                 //
//  cursor_blink(void)-------------------->blink the cursor                //
//  lcd_blank(void)----------------------->blank hole lcd                  //
//  lcd_visible(void)--------------------->shows the lcd                   //
//  lcdcursorLeft(unsigned char n)-------->move cursor n position to left  //
//  lcdcursorRight(unsigned char n)------->move cursor n position to right //

#define clrrs IO1CLR=1<<16;
#define setrs IO1SET=1<<16;
#define clrrw IO1CLR=1<<17;
#define seten IO1SET=1<<18;
#define clren IO1CLR=1<<18;
#define controll  16;
#define data 23;
void delaylcd (void)
{
int j;
for(j=0;j<0xfFF;j++);
}
void comm2 (unsigned char c)
{
 IO1CLR=0xf<<data;
 IO1SET=(c>>4)<<data;
 clrrs;
 clrrw;
 seten;
 clren;
 delaylcd();
 IO1CLR=0xff<<data;
 IO1SET=c<<data;
 clrrs;
 clrrw;
 seten;
 clren;
 delaylcd();
}
void datw (unsigned char c)
{
 IO1CLR=0xf<<data;
 IO1SET=(c>>4)<<data;
 setrs;
 clrrw;
 seten;
 clren;
 delaylcd();
 IO1CLR=0xf<<data;
 IO1SET=c<<data;
 setrs;
 clrrw;
 seten;
 clren;
 delaylcd();
}
void lcd4_init(void)
{
IO1DIR=(0xf<<23)|(0xf<<16); 
comm2(0x33);
comm2(0x32);
comm2(0x28);
comm2(0x01);
comm2(0x06);
comm2(0x0c);
}
void lcd_clear(void)
{
comm2(0x01);
}

void lcd_putchar(char c)
{
datw(c);
}
void lcd_putsf(char  *str)		  
{
char k;
while (k=*str++) lcd_putchar(k);
}
void lcd_puts(char *str)
{
char k;
while (k=*str++) lcd_putchar(k);
}

void lcd_gotoxy(char x,char y)
{
if(y==0){
 comm2(0x80+x);}
if(y==1){
 comm2(0xC0+x);}
}
void cursor_on(void) //displays LCD cursor
{
	comm2(0x0E);
}
void cursor_blink(void)	//displays LCD blinking cursor
{
	comm2(0x0F);
}
void cursor_off(void)	//turns OFF cursor
{
	comm2(0x0C);
}
