 /*
  CodeVisionAVR V2.04.7+ C Compiler
  (C) 1998-2010 Pavel Haiduc, HP InfoTech S.R.L.

  Standard I/O functions
*/

#if __CODEVISIONAVR__ < 2047

#endif

#include <io.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>

#ifdef _USE_FATFS_
#include <ff.h>
#endif

#ifndef NULL
#define NULL 0
#endif

#ifndef EOF
#define EOF -1
#endif

#pragma promotechar-

#ifndef _DEBUG_TERMINAL_IO_
#ifdef _ALTERNATE_GETCHAR_
// an alternative getchar function was defined in another program module
extern char getchar(void);
#else

#ifndef RXC
#define RXC 7
#endif

#ifndef RHR
#define RHR 0
#endif

// these chips don't have an U(S)ART
#if defined _CHIP_ATTINY4_ | defined _CHIP_ATTINY5_ | defined _CHIP_ATTINY9_ | \
defined _CHIP_ATTINY10_ | defined _CHIP_ATTINY20_ | defined _CHIP_ATTINY40_ | \
defined _CHIP_ATTINY13_ | \
defined _CHIP_ATTINY22_ | defined _CHIP_ATTINY22L_ | \
defined _CHIP_ATTINY24_ | defined _CHIP_ATTINY25_ | \
defined _CHIP_ATTINY26_ | defined _CHIP_ATTINY26L_ | \
defined _CHIP_ATTINY261_ | defined _CHIP_ATTINY261V_ | \
defined _CHIP_ATTINY43U_ | \
defined _CHIP_ATTINY44_ | defined _CHIP_ATTINY45_ | \
defined _CHIP_ATTINY48_ | defined _CHIP_ATTINY48V_ | \
defined _CHIP_ATTINY461_ | defined _CHIP_ATTINY461V_ | \
defined _CHIP_ATTINY84_ | defined _CHIP_ATTINY85_ | \
defined _CHIP_ATTINY861_ | defined _CHIP_ATTINY861V_ | \
defined _CHIP_ATTINY88_ | defined _CHIP_ATTINY88V_ | \
defined _CHIP_AT90S2343_ | defined _CHIP_AT90LS2343_ | \
defined _CHIP_AT90C8534_ | \
defined _CHIP_AT86RF401_ | defined _CHIP_AT43USB355_ | \
defined _CHIP_ATA6285_ | defined _CHIP_ATA6286_ | defined _CHIP_ATA6289_ | \
defined _CHIP_ATMEGA8HVA_ | defined _CHIP_ATMEGA16HVA_ | \
defined _CHIP_ATMEGA16HVB_ | defined _CHIP_ATMEGA32HVB_
char getchar(void) {}
// ATxmega chips
#elif defined _ATXMEGA_DEVICE_
char getchar(void)
{
while ((_ATXMEGA_USART_.STATUS & USART_RXCIF_bm)==0);
return _ATXMEGA_USART_.DATA;
}
#elif defined UCSRA
char getchar(void)
{
while ((UCSRA & (1<<RXC))==0);
return UDR;
}
#elif defined UCSR0A
char getchar(void)
{
while ((UCSR0A & (1<<RXC))==0);
return UDR0;
}
// for chips that have only USART1
// 14112009_1
#elif defined _CHIP_AT90USB1286_ | defined _CHIP_AT90USB1287_ | defined _CHIP_AT90USB646_ | defined _CHIP_AT90USB647_ | \
defined _CHIP_AT90USB82_ | defined _CHIP_AT90USB162_ | defined _CHIP_ATMEGA32U6_ | \
defined _CHIP_ATMEGA16U4_ | defined _CHIP_ATMEGA32U4_
char getchar(void)
{
while ((UCSR1A & (1<<RXC))==0);
return UDR1;
}
#elif defined US0_CSR
char getchar(void)
{
while ((US0_CSR & (1<<RHR))==0);
return US0_RHR;
}
// for chips that have LIN/UART
#elif defined _CHIP_ATMEGA16M1_ | defined _CHIP_ATMEGA32M1_ | defined _CHIP_ATMEGA64M1_ | \
defined _CHIP_ATMEGA32C1_ | defined _CHIP_ATMEGA64C1_ | \
defined _CHIP_ATTINY167_ | defined _CHIP_ATTINY87_
char getchar(void)
{
while ((LINSIR & (1<<LRXOK))==0);
return LINDAT;
}
#else
char getchar(void)
{
#asm
getchar0:
     sbis usr,rxc
     rjmp getchar0
     in   r30,udr
#endasm
}
#endif
#endif

#ifdef _ALTERNATE_PUTCHAR_
// an alternative putchar function was defined in another program module
extern void putchar(char c);
#else

#ifndef UDRE
#define UDRE 5
#endif

#ifndef THR
#define THR 1
#endif

// these chips don't have an U(S)ART
#if defined _CHIP_ATTINY4_ | defined _CHIP_ATTINY5_ | defined _CHIP_ATTINY9_ | \
defined _CHIP_ATTINY10_ | defined _CHIP_ATTINY20_ | defined _CHIP_ATTINY40_ | \
defined _CHIP_ATTINY13_ | \
defined _CHIP_ATTINY22_ | defined _CHIP_ATTINY22L_ | \
defined _CHIP_ATTINY24_ | defined _CHIP_ATTINY25_ | \
defined _CHIP_ATTINY26_ | defined _CHIP_ATTINY26L_ | \
defined _CHIP_ATTINY261_ | defined _CHIP_ATTINY261V_ | \
defined _CHIP_ATTINY43U_ | \
defined _CHIP_ATTINY44_ | defined _CHIP_ATTINY45_ | \
defined _CHIP_ATTINY48_ | defined _CHIP_ATTINY48V_ | \
defined _CHIP_ATTINY461_ | defined _CHIP_ATTINY461V_ | \
defined _CHIP_ATTINY84_ | defined _CHIP_ATTINY85_ | \
defined _CHIP_ATTINY861_ | defined _CHIP_ATTINY861V_ | \
defined _CHIP_ATTINY88_ | defined _CHIP_ATTINY88V_ | \
defined _CHIP_AT90S2343_ | defined _CHIP_AT90LS2343_ | \
defined _CHIP_AT90C8534_ | \
defined _CHIP_AT86RF401_ | defined _CHIP_AT43USB355_ | \
defined _CHIP_ATA6285_ | defined _CHIP_ATA6286_ | defined _CHIP_ATA6289_ | \
defined _CHIP_ATMEGA8HVA_ | defined _CHIP_ATMEGA16HVA_ | \
defined _CHIP_ATMEGA16HVB_ | defined _CHIP_ATMEGA32HVB_
void putchar(char c) {}
// ATxmega chips
#elif defined _ATXMEGA_DEVICE_
void putchar(char c)
{
while ((_ATXMEGA_USART_.STATUS & USART_DREIF_bm)==0);
_ATXMEGA_USART_.DATA=c;
}
#elif defined UCSRA
void putchar(char c)
{
while ((UCSRA & (1<<UDRE))==0);
UDR=c;
}
#elif defined UCSR0A
void putchar(char c)
{
while ((UCSR0A & (1<<UDRE))==0);
UDR0=c;
}
// for chips that have only USART1
// 14112009_1
#elif defined _CHIP_AT90USB1286_ | defined _CHIP_AT90USB1287_ | defined _CHIP_AT90USB646_ | defined _CHIP_AT90USB647_ | \
defined _CHIP_AT90USB82_ | defined _CHIP_AT90USB162_ | defined _CHIP_ATMEGA32U6_ | \
defined _CHIP_ATMEGA16U4_ | defined _CHIP_ATMEGA32U4_
void putchar(char c)
{
while ((UCSR1A & (1<<UDRE))==0);
UDR1=c;
}
#elif defined US0_CSR
void putchar(char c)
{
while ((US0_CSR & (1<<THR))==0);
US0_THR=c;
}
// for chips that have LIN/UART
#elif defined _CHIP_ATMEGA16M1_ | defined _CHIP_ATMEGA32M1_ | defined _CHIP_ATMEGA64M1_ | \
defined _CHIP_ATMEGA32C1_ | defined _CHIP_ATMEGA64C1_ | \
defined _CHIP_ATTINY167_ | defined _CHIP_ATTINY87_
void putchar(char c)
{
LINDAT=c;
while ((LINSIR & (1<<LTXOK))==0);
}
#else
void putchar(char c)
{
#asm
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
#endasm
}
#endif
#endif
#endif

void puts(char *str)
{
char k;
while (k=*str++) putchar(k);
putchar(10);
}

void putsf(char flash *str)
{
char k;
while (k=*str++) putchar(k);
putchar(10);
}


#ifdef _USE_FATFS_
int fgetc(FIL *fp)
{
auto unsigned char k;
auto unsigned int br;
if (f_read(fp, &k, 1, &br)!=FR_OK) return EOF;
if (br!=1) return EOF;
return k;
}

char *fgets(char *str,unsigned int len,FIL *fp)
{
char *p=str;
int k;
while (len>1)
      {
      if ((k=fgetc(fp))==EOF) return NULL;
      *p++=(char) k;
      if ((char) k=='\n') break;
      --len;
      };
*p=0;
return str;
}

int fputc(char k,FIL* fp)
{
auto unsigned int bw;
if (f_write(fp, &k, 1, &bw)!=FR_OK) return EOF;
if (bw!=1) return EOF;
return 1;
}

int fputs(char *str,FIL* fp)
{
char k;
while (k=*str++)
      if (fputc(k,fp)<0) return EOF;
return 1;
}

int fputsf(char flash *str,FIL* fp)
{
char k;
while (k=*str++)
      if (fputc(k,fp)<0) return EOF;
return 1;
}

unsigned char feof(FIL* fp)
{
return (fp->fptr == fp->fsize) ? 1 : 0;
}

unsigned char ferror(FIL *fp)
{
return (fp->flag & FA__ERROR) ? 1 : 0;
}
#endif


#ifdef _MODEL_TINY_
char *gets(char *str,unsigned char len)
{
unsigned char n=len;
#else
char *gets(char *str,unsigned int len)
{
unsigned int n=len;
#endif
char *p=str;
char k;

while (n)
      {
      l0:
      k=getchar();
      if (k==8)
         {
         if (len>n)
            {
            --p;
            ++n;
            };
         goto l0;
         };
      if (k==10) break;
      *p++=k;
      --n;
      };
*p=0;
return str;
}

typedef struct
{
int result;
char *ps;
#ifdef _MODEL_TINY_
unsigned char max_size;
#else
unsigned int max_size;
#endif
} ps_print;

static void put_usart(char k,ps_print *ps_ptr)
{
putchar(k);
++(ps_ptr->result);
}

static void put_buff(char k,ps_print *ps_ptr)
{
#ifdef _MODEL_TINY_
unsigned char s;
#else
unsigned int s;
#endif
if (ps_ptr->ps)
   {
   if ((s=ps_ptr->max_size) == 0) goto _put_k;
   if (s > 1)
      {
      ps_ptr->max_size= --s;
      _put_k:
      *(ps_ptr->ps++)=k;
      if (ps_ptr->result >= 0) ++(ps_ptr->result);
      };
   }
else ps_ptr->result=EOF;
}

#ifdef _USE_FATFS_
static void put_file(char k,ps_print *ps_ptr)
{
auto unsigned int bw;
if (f_write((FIL *) ps_ptr->ps,&k,1,&bw) == FR_OK)
   {
   if (bw != 1) goto err;
   if (ps_ptr->result >= 0) ++(ps_ptr->result);
   return;
   }
err:
ps_ptr->result=EOF;
}
#endif

#define TEST_FORMAT 0
#define GET_FLAGS 1
#define GET_PAD_CHAR 2
#define GET_WIDTH 3
#define GET_PRECISION 4
#define DO_PRINT 5

#if defined _PRINTF_INT_ | defined _PRINTF_INT_WIDTH_
static flash unsigned tbl10[]={10000,1000,100,10,1};
static flash unsigned tbl16[]={0x1000,0x100,0x10,1};
#endif

typedef union
{
char *p;
char flash *pf;
} ptr_u;

#if defined _PRINTF_INT_

#define F_SIGNED 1
#define F_CAPS 2
#define F_PAD_CHR0 0x10 // pad char is '0'

static int _print(char flash *fmtstr,va_list argptr,void (*_put)(char,ps_print *),ps_print *ps_ptr)
{
unsigned char l=TEST_FORMAT,flags,k,s;
unsigned n,i;
ptr_u pp;

ps_ptr->result=0;
while (k=*fmtstr++)
      switch (l)
             {
             case TEST_FORMAT: if (k=='%') l=GET_FLAGS; else _put(k,ps_ptr);
                     break;
             case GET_FLAGS: if (k=='%') {_put(k,ps_ptr); l=TEST_FORMAT; break;};
                     l=GET_PAD_CHAR;
                     s=0;
                     flags=0;
                     if (k=='+') {s='+'; break;};
                     if (k==' ') {s=' '; break;};
             case GET_PAD_CHAR:
                     if (k=='0') {flags|=F_PAD_CHR0; l=DO_PRINT; break;}
             case DO_PRINT:
                     switch (k)
                        {
                        case 'c':
                            _put(va_arg(argptr,char),ps_ptr);
                            goto next;

                        case 's':
                            pp.p=va_arg(argptr,char *);
                            while (k=*pp.p++) _put(k,ps_ptr);
                            goto next;

                        case 'p':
                            pp.pf=va_arg(argptr,char flash *);
                            while (k=*pp.pf++) _put(k,ps_ptr);
                            goto next;

                        case 'd':
                        case 'i':
                            flags|=F_SIGNED;
                        case 'u':
                            pp.pf=(char flash *)tbl10;
                            goto get_arg;

                        case 'X':
                            flags|=F_CAPS;
                        case 'x':
                            pp.pf=(char flash *) tbl16;
                            get_arg:
                            if (flags & F_SIGNED)
                               {
                               n=va_arg(argptr,int);
                               if ((int)n<0)
                                  {
                                  n=-(int) n;
                                  s='-';
                                  };
                               if (s) _put(s,ps_ptr);
                               }
                            else n=va_arg(argptr,unsigned);
                            do
                              {
                              k='0';
                              i=*(unsigned flash *) pp.pf;
                              pp.pf += sizeof(unsigned);
                              while (n>=i)
                                    {
                                    ++k;
                                    n-=i;
                                    };
                              if ((flags & F_PAD_CHR0) || (k>'0') || (i==1))
                                 {
                                 flags|=F_PAD_CHR0;
                                 if (k>'9')
                                    {
                                    if (flags & F_CAPS) k+=7;
                                    else k+=0x27;
                                    };
                                 _put(k,ps_ptr);
                                 };
                              }
                            while (i>1);
                        default:
                            next:
                            l=TEST_FORMAT;
                        };
             };
return ps_ptr->result;
}
#elif defined _PRINTF_INT_WIDTH_

#define F_LEFT_JUSTIFY 1
#define F_STRING 2
#define F_SIGNED 4
#define F_CAPS 8
#define F_STRING_FLASH 8
#define F_NON_ZERO 0x10
#define F_PAD_CHR0 0x80 // pad char is '0'

static int _print(char flash *fmtstr,va_list argptr,void (*_put)(char,ps_print *),ps_print *ps_ptr)
{
unsigned char l=TEST_FORMAT,flags,j,k,width,s;
unsigned n,i;
ptr_u pp;

ps_ptr->result=0;
while (k=*fmtstr++)
      switch (l)
             {
             case TEST_FORMAT: if (k=='%') l=GET_FLAGS; else _put(k,ps_ptr);
                     break;
             case GET_FLAGS: if (k=='%') {_put(k,ps_ptr); l=TEST_FORMAT; break;};
                     l=GET_PAD_CHAR;
                     s=0;
                     flags=0;
                     if (k=='-') {flags=F_LEFT_JUSTIFY; break;};
                     if (k=='+') {s='+'; break;};
                     if (k==' ') {s=' '; break;};
             case GET_PAD_CHAR:
                     width=0;
                     l=GET_WIDTH;
                     if (k=='0') {flags|=F_PAD_CHR0; break;}
             case GET_WIDTH:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        #ifdef _ENHANCED_CORE_
                        width*=10;
                        #else
                        j=width;
                        width<<=2;
                        width+=j;
                        width<<=1;
                        #endif
                        width+=k-'0';
                        break;
                        };

                     switch (k)
                        {
                        case 'c':
                            _put(va_arg(argptr,char),ps_ptr);
                            goto next;

                        case 's':
                            pp.p=va_arg(argptr,char *);
                            l=strlen(pp.p);
                            goto disp_string;

                        case 'p':
                            pp.pf=va_arg(argptr,char flash *);
                            l=strlenf(pp.pf);
                            flags|=F_STRING_FLASH;
                            disp_string:
                            flags|=F_STRING;
                            flags&=~F_PAD_CHR0;
                            j=0;
                            goto pad_left;

                        case 'd':
                        case 'i':
                            flags|=F_SIGNED;
                        case 'u':
                            pp.pf=(char flash *) tbl10; l=5;
                            goto get_arg;

                        case 'X':
                            flags|=F_CAPS;
                        case 'x':
                            pp.pf=(char flash *) tbl16; l=4;
                            get_arg:
                            if (flags & F_SIGNED)
                               {
                               n=va_arg(argptr,int);
                               if ((int)n<0)
                                  {
                                  n=-(int) n;
                                  s='-';
                                  };
                               if (s) ++l;
                               else flags&=~F_SIGNED;
                               }
                            else n=va_arg(argptr,unsigned);
                            pad_left:
                            if ((flags & F_LEFT_JUSTIFY)==0)
                               while (width>l)
                                     {
                                     if (flags & F_PAD_CHR0)
                                        {
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           k=s;
                                           --l;
                                           }
                                        else k='0';
                                        }
                                     else k=' ';
                                     _put(k,ps_ptr);
                                     --width;
                                     };
                            j=l;

                            if (flags & F_STRING)
                               {
                               while (j)
                                     {
                                     if (flags & F_STRING_FLASH) k=*pp.pf++; else k=*pp.p++;
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     --j;
                                     };
                               }
                            else
                                do
                                  {
                                  k='0';
                                  i=*(unsigned flash *) pp.pf;
                                  pp.pf += sizeof(unsigned);
                                  while (n>=i)
                                        {
                                        ++k;
                                        n-=i;
                                        };
                                  if (k>'9')
                                     {
                                     if (flags & F_CAPS) k+=7;
                                     else k+=0x27;
                                     };
                                  if (flags & F_NON_ZERO) goto print_digit;
                                  if ((k>'0') || (i==1))
                                     {
                                     flags|=F_NON_ZERO;
                                     goto print_sign;
                                     };
                                  if ((width>=j) && ((flags & F_LEFT_JUSTIFY)==0))
                                     {
                                     k=' ';
                                     if (flags & F_PAD_CHR0)
                                        {
                                        k='0';
                                        flags|=F_NON_ZERO;
                                        print_sign:
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           _put(s,ps_ptr);
                                           if (width) --width;
                                           };
                                        };
                                     print_digit:
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     };
                                  --j;
                                  }
                                while (i>1);
                            if (flags & F_LEFT_JUSTIFY)
                               while (width)
                                     {
                                     --width;
                                     _put(' ',ps_ptr);
                                     };
                        default:
                            next:
                            l=TEST_FORMAT;
                        };
             };
return ps_ptr->result;
}
#elif defined _PRINTF_LONG_WIDTH_

#define F_LEFT_JUSTIFY 1
#define F_LONG 2
#define F_SIGNED 4
#define F_CAPS 8
#define F_STRING_FLASH 8
#define F_NON_ZERO 0x10
#define F_PAD_CHR0 0x80 // pad char is '0'

static int _print(char flash *fmtstr,va_list argptr,void (*_put)(char,ps_print *),ps_print *ps_ptr)
{
unsigned char l=TEST_FORMAT,flags,j,k,width,s,base;
unsigned long n,i;
ptr_u pp;

ps_ptr->result=0;
while (k=*fmtstr++)
      switch (l)
             {
             case TEST_FORMAT: if (k=='%') l=GET_FLAGS; else _put(k,ps_ptr);
                     break;
             case GET_FLAGS: if (k=='%') {_put(k,ps_ptr); l=TEST_FORMAT; break;};
                     l=GET_PAD_CHAR;
                     s=0;
                     flags=0;
                     if (k=='-') {flags=F_LEFT_JUSTIFY; break;};
                     if (k=='+') {s='+'; break;};
                     if (k==' ') {s=' '; break;};
             case GET_PAD_CHAR:
                     width=0;
                     l=GET_WIDTH;
                     if (k=='0') {flags|=F_PAD_CHR0; break;}
             case GET_WIDTH:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        #ifdef _ENHANCED_CORE_
                        width*=10;
                        #else
                        j=width;
                        width<<=2;
                        width+=j;
                        width<<=1;
                        #endif
                        width+=k-'0';
                        break;
                        };
                     if (k=='l')
                        {
                        flags|=F_LONG;
                        l=DO_PRINT;
                        break;
                        };
             case DO_PRINT:
                     switch (k)
                        {
                        case 'c':
                            _put(va_arg(argptr,char),ps_ptr);
                            goto next;

                        case 's':
                            pp.p=va_arg(argptr,char *);
                            l=strlen(pp.p);
                            goto disp_string;

                        case 'p':
                            pp.pf=va_arg(argptr,char flash *);
                            l=strlenf(pp.pf);
                            flags|=F_STRING_FLASH;
                            disp_string:
                            flags&=~F_PAD_CHR0;
                            base=0;
                            j=0;
                            goto pad_left;

                        case 'd':
                        case 'i':
                            flags|=F_SIGNED;
                        case 'u':
                            base=10;
                            if (flags & F_LONG)
                               {i=1000000000L; l=10; goto get_arg;};
                            i=10000; l=5;
                            goto get_arg;

                        case 'X':
                            flags|=F_CAPS;
                        case 'x':
                            base=16;
                            if (flags & F_LONG)
                               {i=0x10000000L; l=8; goto get_arg;};
                            i=0x1000; l=4;
                            get_arg:
                            if (flags & F_LONG) n=va_arg(argptr,long);
                            else
                            if (flags & F_SIGNED) n=va_arg(argptr,int);
                            else n=va_arg(argptr,unsigned);
                            if (flags & F_SIGNED)
                               {
                               if ((long)n<0)
                                  {
                                  n=-(long) n;
                                  s='-';
                                  };
                               if (s) ++l;
                               else flags&=~F_SIGNED;
                               };
                            pad_left:
                            if ((flags & F_LEFT_JUSTIFY)==0)
                               while (width>l)
                                     {
                                     if (flags & F_PAD_CHR0)
                                        {
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           k=s;
                                           --l;
                                           }
                                        else k='0';
                                        }
                                     else k=' ';
                                     _put(k,ps_ptr);
                                     --width;
                                     };
                            j=l;
                            if (base==0)
                               {
                               while (j)
                                     {
                                     if (flags & F_STRING_FLASH) k=*pp.pf++; else k=*pp.p++;
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     --j;
                                     };
                               }
                            else
                                do
                                  {
                                  k=(unsigned char) (n/i);
                                  if (k>9)
                                     {
                                     if (flags & F_CAPS) k+=0x37;
                                     else k+=0x57;
                                     }
                                  else k+='0';

                                  if (flags & F_NON_ZERO) goto print_digit;
                                  if ((k>'0') || (i==1)) goto print_sign;
                                  if ((width>=j) && ((flags & F_LEFT_JUSTIFY)==0))
                                     {
                                     k=' ';
                                     if (flags & F_PAD_CHR0)
                                        {
                                        k='0';
                                        print_sign:
                                        flags|=F_NON_ZERO;
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           _put(s,ps_ptr);
                                           if (width) --width;
                                           };
                                        };
                                     print_digit:
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     };
                                  --j;
                                  n%=i;
                                  i/=base;
                                  }
                                while (i);
                            if (flags & F_LEFT_JUSTIFY)
                               while (width)
                                     {
                                     --width;
                                     _put(' ',ps_ptr);
                                     };
                        default:
                            next:
                            l=TEST_FORMAT;
                        };
             };
return ps_ptr->result;
}
#elif defined _PRINTF_LONG_WIDTH_PRECISION_

#define F_LEFT_JUSTIFY 1
#define F_LONG 2
#define F_SIGNED 4
#define F_CAPS 8
#define F_STRING_FLASH 8
#define F_NON_ZERO 0x10
#define F_PAD_CHR0 0x80 // pad char is '0'

#define _PRINT_SIGN() {flags&=~F_SIGNED; _put(s,ps_ptr); if (width) --width;}

static int _print(char flash *fmtstr,va_list argptr,void (*_put)(char,ps_print *),ps_print *ps_ptr)
{
unsigned char l=TEST_FORMAT,flags,j,k,width,precision,s,base;
unsigned long n,i;
ptr_u pp;

ps_ptr->result=0;
while (k=*fmtstr++)
      switch (l)
             {
             case TEST_FORMAT: if (k=='%') l=GET_FLAGS; else _put(k,ps_ptr);
                     break;
             case GET_FLAGS: if (k=='%') {_put(k,ps_ptr); l=TEST_FORMAT; break;};
                     l=GET_PAD_CHAR;
                     s=0;
                     flags=0;
                     if (k=='-') {flags=F_LEFT_JUSTIFY; break;};
                     if (k=='+') {s='+'; break;};
                     if (k==' ') {s=' '; break;};
             case GET_PAD_CHAR:
                     width=0;
                     l=GET_WIDTH;
                     if (k=='0') {flags|=F_PAD_CHR0; break;}
             case GET_WIDTH:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        #ifdef _ENHANCED_CORE_
                        width*=10;
                        #else
                        j=width;
                        width<<=2;
                        width+=j;
                        width<<=1;
                        #endif
                        width+=k-'0';
                        break;
                        };
                     precision=0;
                     if (k=='.') {l=GET_PRECISION; break;}
                     goto test_long;
             case GET_PRECISION:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        #ifdef _ENHANCED_CORE_
                        precision*=10;
                        #else
                        j=precision;
                        precision<<=2;
                        precision+=j;
                        precision<<=1;
                        #endif
                        precision+=k-'0';
                        break;
                        };
                     test_long:
                     if (k=='l')
                        {
                        flags|=F_LONG;
                        l=DO_PRINT;
                        break;
                        };
             case DO_PRINT:
                     switch (k)
                        {
                        case 'c':
                            _put(va_arg(argptr,char),ps_ptr);
                            goto next;

                        case 's':
                            pp.p=va_arg(argptr,char *);
                            l=strlen(pp.p);
                            goto disp_string;

                        case 'p':
                            pp.pf=va_arg(argptr,char flash *);
                            l=strlenf(pp.pf);
                            flags|=F_STRING_FLASH;
                            disp_string:
                            flags&=~F_PAD_CHR0;
                            if (precision && (l>precision))
                               l=precision;
                            precision=0;
                            base=0;
                            j=0;
                            goto pad_left;

                        case 'd':
                        case 'i':
                            flags|=F_SIGNED;
                        case 'u':
                            base=10;
                            if (flags & F_LONG)
                               {i=1000000000L; l=10; goto get_arg;};
                            i=10000; l=5;
                            goto get_arg;

                        case 'X':
                            flags|=F_CAPS;
                        case 'x':
                            base=16;
                            if (flags & F_LONG)
                               {i=0x10000000L; l=8; goto get_arg;};
                            i=0x1000; l=4;
                            get_arg:
                            if (precision) flags&=~F_PAD_CHR0;
                            else precision=1;
                            if (flags & F_LONG) n=va_arg(argptr,long);
                            else
                            if (flags & F_SIGNED) n=va_arg(argptr,int);
                            else n=va_arg(argptr,unsigned);
                            if (flags & F_SIGNED)
                               {
                               if ((long)n<0)
                                  {
                                  n=-(long) n;
                                  s='-';
                                  };
                               if (s) {++l; ++precision;}
                               else flags&=~F_SIGNED;
                               };
                            j=precision;
                            pad_left:
                            if ((flags & F_LEFT_JUSTIFY)==0)
                               while ((width>l) && (width>j))
                                     {
                                     if (flags & F_PAD_CHR0)
                                        {
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           k=s;
                                           --l;
                                           }
                                        else k='0';
                                        }
                                     else k=' ';
                                     _put(k,ps_ptr);
                                     --width;
                                     };
                            while (precision>l)
                                  {
                                  flags|=F_NON_ZERO;
                                  if (flags & F_SIGNED)
                                     {
                                     _PRINT_SIGN();
                                     --l;
                                     --precision;
                                     };
                                  _put('0',ps_ptr);
                                  if (width) --width;
                                  --precision;
                                  };
                            j=l;
                            if (base==0)
                               {
                               while (j)
                                     {
                                     if (flags & F_STRING_FLASH) k=*pp.pf++; else k=*pp.p++;
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     --j;
                                     };
                               }
                            else
                                do
                                  {
                                  k=(unsigned char) (n/i);
                                  if (k>9)
                                     {
                                     if (flags & F_CAPS) k+=0x37;
                                     else k+=0x57;
                                     }
                                  else k+='0';
                                  if (flags & F_NON_ZERO) goto print_digit;
                                  if ((k>'0') || (i==1)) goto print_sign;
                                  if (precision>=j)
                                     {
                                     k='0';
                                     goto print_sign;
                                     };
                                  if ((width>=j) && ((flags & F_LEFT_JUSTIFY)==0))
                                     {
                                     k=' ';
                                     if (flags & F_PAD_CHR0)
                                        {
                                        k='0';
                                        print_sign:
                                        flags|=F_NON_ZERO;
                                        if (flags & F_SIGNED) _PRINT_SIGN();
                                        };
                                     print_digit:
                                     _put(k,ps_ptr);
                                     if (width) --width;
                                     };
                                  --j;
                                  n%=i;
                                  i/=base;
                                  }
                                while (i);
                            if (flags & F_LEFT_JUSTIFY)
                               while (width)
                                     {
                                     --width;
                                     _put(' ',ps_ptr);
                                     };
                        default:
                            next:
                            l=TEST_FORMAT;
                        };
             };
return ps_ptr->result;
}
#elif defined _PRINTF_FLOAT_WIDTH_PRECISION_

#include <math.h>
#include <stdlib.h>
#include <string.h>

#define F_LEFT_JUSTIFY 1
#define F_LONG 2
#define F_SIGNED 4
#define F_CAPS 8
#define F_STRING_FLASH 8
#define F_NON_ZERO 0x10
#define F_USE_PRECISION 0x20
#define F_PAD_CHR0 0x80 // pad char is '0'

static void _ftoe(float n,unsigned char decimals,char e,char *str)
{
float scale=1.0;
unsigned char i,d;
signed char expon;

switch (((unsigned int *) &n)[1])
       {
       case 0xFFFF:
       strcpyf(str,"-NAN");
       return;

       case 0x7FFF:
       strcpyf(str,"NAN");
       return;
       };

if (decimals>6) decimals=6;
i=decimals;
while (i--) scale=scale*10.0;
if (n==0.0) {expon=0; scale=scale*10.0;}
else
    {
    expon=decimals;
    if (n>scale)
       {
       scale=scale*10.;
       while (n>=scale) {n=n*0.1; ++expon;};
       }
    else
       {
       while (n<scale) {n=n*10.0; --expon;};
       scale=scale*10.0;
       };
    n+=0.5;
    if (n>=scale) {n=n*0.1; ++expon;};
    }
i=0;
while (i<=decimals)
      {
      scale=floor(0.5+scale*0.1);
      d=(unsigned char) (n/scale);
      *str++=d+'0';
      n=n-(float) d*scale;
      if (i++) continue;
      *str++ ='.';
      };
*str++=e;
// 26012010_3
if (expon<0)
   {
   expon=-expon;
   *str='-';
   }
else
   *str='+';
++str;
*str++='0'+expon/10;
*str++='0'+expon%10;
*str=0;
}

#define _PRINT_SIGN() {flags&=~F_SIGNED; _put(s,ps_ptr); if (width) --width;}

static int _print(char flash *fmtstr,va_list argptr,void (*_put)(char,ps_print *),ps_print *ps_ptr)
{
char pbuf[64];
unsigned char l=TEST_FORMAT,flags,j,k,width,precision,s,base;
unsigned long i;
ptr_u pp;
union {
      unsigned long n;
      float nf;
      } arg_val;
void (*put)(char,ps_print *)=_put;
ps_print *ps_ptr0=ps_ptr;

ps_ptr0->result=0;
while (k=*fmtstr++)
      switch (l)
             {
             case TEST_FORMAT: if (k=='%') l=GET_FLAGS; else put(k,ps_ptr0);
                     break;
             case GET_FLAGS: if (k=='%') {put(k,ps_ptr0); l=TEST_FORMAT; break;};
                     l=GET_PAD_CHAR;
                     s=0;
                     flags=0;
                     if (k=='-') {flags=F_LEFT_JUSTIFY; break;};
                     if (k=='+') {s='+'; break;};
                     if (k==' ') {s=' '; break;};
             case GET_PAD_CHAR:
                     width=0;
                     l=GET_WIDTH;
                     if (k=='0') {flags|=F_PAD_CHR0; break;}
             case GET_WIDTH:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        #ifdef _ENHANCED_CORE_
                        width*=10;
                        #else
                        j=width;
                        width<<=2;
                        width+=j;
                        width<<=1;
                        #endif
                        width+=k-'0';
                        break;
                        };
                     precision=0;
                     if (k=='.') {l=GET_PRECISION; break;}
                     goto test_long;
             case GET_PRECISION:
                     if ((k>='0') && (k<('9'+1)))
                        {
                        flags|=F_USE_PRECISION;
                        #ifdef _ENHANCED_CORE_
                        precision*=10;
                        #else
                        j=precision;
                        precision<<=2;
                        precision+=j;
                        precision<<=1;
                        #endif
                        precision+=k-'0';
                        break;
                        };
                     test_long:
                     if (k=='l')
                        {
                        flags|=F_LONG;
                        l=DO_PRINT;
                        break;
                        };
             case DO_PRINT:
                     switch (k)
                        {
                        case 'c':
                            put(va_arg(argptr,char),ps_ptr0);
                            goto next;

                        case 'E':
                        case 'e':
                        case 'f':
                            pp.p=pbuf;
                            arg_val.nf=*((float *) argptr);
                            argptr-=sizeof(float);
                            if (arg_val.nf>=0)
                               {
                               if (s=='+') goto disp_sign;
                               }
                            else
                               {
                               arg_val.nf=-arg_val.nf;
                               s='-';
                               disp_sign:
                               if (flags & F_PAD_CHR0) put(s,ps_ptr0);
                               else *pp.p++=s;
                               };
                            if ((flags & F_USE_PRECISION)==0) precision=6;
                            if (k=='f') ftoa(arg_val.nf,precision,pp.p);
                            else _ftoe(arg_val.nf,precision,k,pp.p);
                            pp.p=pbuf;
                            l=strlen(pp.p);
                            goto disp_string1;

                        case 's':
                            pp.p=va_arg(argptr,char *);
                            l=strlen(pp.p);
                            goto disp_string0;

                        case 'p':
                            pp.pf=va_arg(argptr,char flash *);
                            l=strlenf(pp.pf);
                            flags|=F_STRING_FLASH;
                            disp_string0:
                            flags&=~F_PAD_CHR0;
                            if (precision && (l>precision))
                               l=precision;
                            disp_string1:
                            precision=0;
                            base=0;
                            j=0;
                            goto pad_left;

                        case 'd':
                        case 'i':
                            flags|=F_SIGNED;
                        case 'u':
                            base=10;
                            if (flags & F_LONG)
                               {i=1000000000L; l=10; goto get_arg;};
                            i=10000; l=5;
                            goto get_arg;

                        case 'X':
                            flags|=F_CAPS;
                        case 'x':
                            base=16;
                            if (flags & F_LONG)
                               {i=0x10000000L; l=8; goto get_arg;};
                            i=0x1000; l=4;
                            get_arg:
                            if (precision) flags&=~F_PAD_CHR0;
                            else precision=1;
                            if (flags & F_LONG) arg_val.n=va_arg(argptr,long);
                            else
                            if (flags & F_SIGNED) arg_val.n=va_arg(argptr,int);
                            else arg_val.n=va_arg(argptr,unsigned);
                            if (flags & F_SIGNED)
                               {
                               if ((long) arg_val.n<0)
                                  {
                                  arg_val.n=-(long) arg_val.n;
                                  s='-';
                                  };
                               if (s) {++l; ++precision;}
                               else flags&=~F_SIGNED;
                               };
                            j=precision;
                            pad_left:
                            if ((flags & F_LEFT_JUSTIFY)==0)
                               while ((width>l) && (width>j))
                                     {
                                     if (flags & F_PAD_CHR0)
                                        {
                                        if (flags & F_SIGNED)
                                           {
                                           flags&=~F_SIGNED;
                                           k=s;
                                           --l;
                                           }
                                        else k='0';
                                        }
                                     else k=' ';
                                     put(k,ps_ptr0);
                                     --width;
                                     };
                            while (precision>l)
                                  {
                                  flags|=F_NON_ZERO;
                                  if (flags & F_SIGNED)
                                     {
                                     _PRINT_SIGN();
                                     --l;
                                     --precision;
                                     };
                                  put('0',ps_ptr0);
                                  if (width) --width;
                                  --precision;
                                  };
                            j=l;
                            if (base==0)
                               {
                               while (j)
                                     {
                                     if (flags & F_STRING_FLASH) k=*pp.pf++; else k=*pp.p++;
                                     put(k,ps_ptr0);
                                     if (width) --width;
                                     --j;
                                     };
                               }
                            else
                                do
                                  {
                                  k=(unsigned char) (arg_val.n/i);
                                  if (k>9)
                                     {
                                     if (flags & F_CAPS) k+=0x37;
                                     else k+=0x57;
                                     }
                                  else k+='0';
                                  if (flags & F_NON_ZERO) goto print_digit;
                                  if ((k>'0') || (i==1)) goto print_sign;
                                  if (precision>=j)
                                     {
                                     k='0';
                                     goto print_sign;
                                     };
                                  if ((width>=j) && ((flags & F_LEFT_JUSTIFY)==0))
                                     {
                                     k=' ';
                                     if (flags & F_PAD_CHR0)
                                        {
                                        k='0';
                                        print_sign:
                                        flags|=F_NON_ZERO;
                                        if (flags & F_SIGNED) _PRINT_SIGN();
                                        };
                                     print_digit:
                                     put(k,ps_ptr0);
                                     if (width) --width;
                                     };
                                  --j;
                                  arg_val.n%=i;
                                  i/=base;
                                  }
                                while (i);
                            if (flags & F_LEFT_JUSTIFY)
                               while (width)
                                     {
                                     --width;
                                     put(' ',ps_ptr0);
                                     };
                        default:
                            next:
                            l=TEST_FORMAT;
                        };
             };
return ps_ptr0->result;
}
#endif

int sprintf(char *str,char flash *fmtstr,...)
{
va_list argptr;
ps_print p;
int res;
if (str==NULL) return EOF;
va_start(argptr,fmtstr);
p.ps=str;
p.max_size=0;
res=_print(fmtstr,argptr,put_buff,&p);
*p.ps=0;
return res;
}

#ifdef _MODEL_TINY_
int snprintf(char *str, unsigned char size, char flash *fmtstr,...)
#else
int snprintf(char *str, unsigned int size, char flash *fmtstr,...)
#endif
{
va_list argptr;
ps_print p;
int res=0;
if (str==NULL) return EOF;
if (size)
   {
   va_start(argptr,fmtstr);
   p.ps=str;
   p.max_size=size;
   res=_print(fmtstr,argptr,put_buff,&p);
   *p.ps=0;
   };
return res;
}

int vsprintf(char *str,char flash *fmtstr,va_list argptr)
{
ps_print p;
int res;
if (str==NULL) return EOF;
p.ps=str;
p.max_size=0;
res=_print(fmtstr,argptr,put_buff,&p);
*p.ps=0;
return res;
}

#ifdef _MODEL_TINY_
int vsnprintf (char *str, unsigned char size, char flash * fmtstr, va_list argptr)
#else
int vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr)
#endif
{
ps_print p;
int res=0;
if (str==NULL) return EOF;
if (size)
   {
   p.ps=str;
   p.max_size=size;
   res=_print(fmtstr,argptr,put_buff,&p);
   *p.ps=0;
   };
return res;
}

int printf(char flash *fmtstr,...)
{
va_list argptr;
ps_print p;
va_start(argptr,fmtstr);
p.ps=NULL;
p.max_size=0;
return _print(fmtstr,argptr,put_usart,&p);
}

int vprintf(char flash *fmtstr,va_list argptr)
{
ps_print p;
p.ps=NULL;
p.max_size=0;
return _print(fmtstr,argptr,put_usart,&p);
}

#ifdef _USE_FATFS_
int fprintf(FIL *fp,char flash *fmtstr,...)
{
va_list argptr;
ps_print p;
if (fp==NULL) return EOF;
va_start(argptr,fmtstr);
p.ps=(char *) fp;
p.max_size=0;
return _print(fmtstr,argptr,put_file,&p);
}
#endif

typedef struct
{
signed char result;
char *ps;
} ps_scan;

static char get_usart(char *ptr_cc,ps_scan *ptr_ps)
{
char k;
ptr_ps->result=0;
if (k=*ptr_cc) *ptr_cc=0;
else k=getchar();
return k;
}

static char get_buff(char *ptr_cc,ps_scan *ptr_ps)
{
char k;
ptr_ps->result=0;
if (k=*ptr_cc) *ptr_cc=0;
else if (ptr_ps->ps)
   {
   if (k=*(ptr_ps->ps)) ++(ptr_ps->ps);
   }
else k=0;
return k;
}

#ifdef _USE_FATFS_
static char get_file(char *ptr_cc,ps_scan *ptr_ps)
{
auto char k;
auto unsigned int br;
ptr_ps->result=0;
if (k=*ptr_cc) *ptr_cc=0;
else
    {
    if (f_read((FIL*) ptr_ps->ps,&k,1,&br) == FR_OK)
       {
       if (br != 1) goto err;
       }
    else
       {
       err:
       ptr_ps->result=EOF;
       k=0;
       };
    };
return k;
}
#endif

#ifdef _SCANF_INT_WIDTH_
static int _scanf(char flash *fmtstr,va_list argptr,char (*_get)(char *,ps_scan *), ps_scan *ptr_ps)
{
char *parg;
unsigned char k,b,width;
char cc;
signed char s;
int ns;
unsigned int n;

cc=ns=0;
while (k=*fmtstr++)
      {
      if (isspace(k))
         {
         while ((k=_get(&cc,ptr_ps)) && isspace(k))
               {
               if (ptr_ps->result < 0) return EOF;
               };
         cc=k;
         }
      else if (k=='%')
         {
         width=0;
         while (1)
               {
               k=*fmtstr++;
               if ((k<'0')||(k>'9')) break;
               width*=10;
               width+=k-'0';
               };
         if (k==0) break;
    	    while (isspace(b=_get(&cc,ptr_ps)))
               {
               if (ptr_ps->result < 0) return EOF;
               };
         if (b==0) goto _scan_end;
         cc=b;
         if (width==0) width=255;
         switch (k)
             {
             case 'c':
             parg=(void *) va_arg(argptr,char *);
             *parg=_get(&cc,ptr_ps);
             if (ptr_ps->result < 0) return EOF;
             break;

             case 's':
             parg=(void *) va_arg(argptr,char *);
             while (width--)
                   {
                   if (((k=_get(&cc,ptr_ps))==0) || isspace(k))
                      {
                      if (ptr_ps->result < 0) return EOF;
                      break;
                      };
                   *parg++=k;
                   };
             *parg=0;
             break;

             default:
             s=1;
             switch (k)
                    {
                    case 'd':
                    case 'i': s=0;
                    case 'u': b=10; break;
                    case 'x': b=16; break;
                    case '%': goto _scan_cmp;
                    default:  return ns;
                    };
             n=0;
             while (width--)
                   {
                   if ((k=_get(&cc,ptr_ps))<=' ')
                      {
                      if (ptr_ps->result < 0) return EOF;
                      goto _scan_next;
                      };
                   if (s==0)
                      {
                      if (k=='-') {s=-1; continue;}
                      else s=1;
                      };
                   if (b==16)
                      {
                      if (!isxdigit(k)) goto _scan_next;
                      }
                   else
                   if (!isdigit(k))
                      {
                      _scan_next:
                      cc=k;
                      break;
                      };
                   if (k>='a') k-=0x57;
                   else if(k>='A') k-=0x37;
                   else k-='0';
                   n=n*b+k;
                   };
             parg=(char *) va_arg(argptr,int *);
             *(int *)parg=n*s;
             };
         ++ns;
         }
      else
         {
         _scan_cmp:
         if (k!=_get(&cc,ptr_ps))
            {
            if (ptr_ps->result < 0) return EOF;
            _scan_end:
            if (ns==0) return EOF;
            break;
            };
         };
      };
return ns;
}
#elif defined _SCANF_LONG_WIDTH_
static int _scanf(char flash *fmtstr,va_list argptr,char (*_get)(char *,ps_scan *),ps_scan *ptr_ps)
{
char *parg;
unsigned char k,b,width,long_flag;
char cc;
signed char s;
int ns;
unsigned long n;

cc=ns=0;
while (k=*fmtstr++)
      {
      if (isspace(k))
         {
         while ((k=_get(&cc,ptr_ps)) && isspace(k))
               {
               if (ptr_ps->result < 0) return EOF;
               };
         cc=k;
         }
      else if (k=='%')
         {
         width=0;
         while (1)
               {
               k=*fmtstr++;
               if ((k<'0')||(k>'9')) break;
               width*=10;
               width+=k-'0';
               };
         if (k==0) break;
    	    while (isspace(b=_get(&cc,ptr_ps)))
               {
               if (ptr_ps->result < 0) return EOF;
               };
         if (b==0) goto _scan_end;
         cc=b;
         if (width==0) width=255;
    	    long_flag=0;
         switch (k)
             {
             case 'c':
             parg=(void *) va_arg(argptr,char *);
             *parg=_get(&cc,ptr_ps);
             if (ptr_ps->result < 0) return EOF;
             break;

             case 's':
             parg=(void *) va_arg(argptr,char *);
             while (width--)
                   {
                   if (((k=_get(&cc,ptr_ps))==0) || isspace(k))
                      {
                      if (ptr_ps->result < 0) return EOF;
                      break;
                      };
                   *parg++=k;
                   };
             *parg=0;
             break;

             case 'l':
    	     long_flag=1;
    	     k=*fmtstr++;

             default:
             s=1;
             switch (k)
                    {
                    case 'd':
                    case 'i': s=0;
                    case 'u': b=10; break;
                    case 'x': b=16; break;
                    case '%': goto _scan_cmp;
                    default:  return ns;
                    };
             n=0;
             while (width--)
                   {
                   if ((k=_get(&cc,ptr_ps))<=' ')
                      {
                      if (ptr_ps->result < 0) return EOF;
                      goto _scan_next;
                      };
                   if (s==0)
                      {
                      if (k=='-') {s=-1; continue;}
                      else s=1;
                      };
                   if (b==16)
                      {
                      if (!isxdigit(k)) goto _scan_next;
                      }
                   else
                   if (!isdigit(k))
                      {
                      _scan_next:
                      cc=k;
                      break;
                      };
                   if (k>='a') k-=0x57;
                   else if(k>='A') k-=0x37;
                   else k-='0';
                   n=n*b+k;
                   };
             n=n*s;
             if (long_flag)
                {
                parg=(char *) va_arg(argptr,long *);
                *(long *)parg=n;
                }
             else
                {
                parg=(char *) va_arg(argptr,int *);
                *(int *)parg=(int) n;
                };
             };
         ++ns;
         }
      else
         {
         _scan_cmp:
         if (k!=_get(&cc,ptr_ps))
            {
            if (ptr_ps->result < 0) return EOF;
            _scan_end:
            if (ns==0) return EOF;
            break;
            };
         };
      };
return ns;
}
#endif

int sscanf(char *str,char flash *fmtstr,...)
{
va_list argptr;
ps_scan p;
if (str==NULL) return EOF;
va_start(argptr,fmtstr);
p.ps=str;
return _scanf(fmtstr,argptr,get_buff,&p);
}

int scanf(char flash *fmtstr,...)
{
va_list argptr;
ps_scan p;
va_start(argptr,fmtstr);
p.ps=NULL;
return _scanf(fmtstr,argptr,get_usart,&p);
}

#ifdef _USE_FATFS_
int fscanf(FIL *fp,char flash *fmtstr,...)
{
va_list argptr;
ps_scan p;
if (fp==NULL) return EOF;
va_start(argptr,fmtstr);
p.ps=(char *) fp;
return _scanf(fmtstr,argptr,get_file,&p);
}
#endif
